package org.system.newEditor;

import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;

import org.sprite.animed.Pnj;
import org.system.ListePnj;

/**
 * Classe qui coute l'interface graphique pour dtecter si on clique/dplace un pnj
 * Ncessite aucun mode d'dition activ et que la touche alt ne sois pas enfonce
 * pour ne pas s'executer en meme temps que la slection de plusieurs cases (SelectionneurMultiple.java)
 * @author Groupe 6 - 2009
 */
public class ActionDeplacerPnj implements MouseListener, MouseMotionListener{

	/** La liste des pnj */
	private ListePnj liste;
	/** Pnj slectionn (null si aucun) */
	private Pnj pnj;
	/** l'interface graphique */
	private AfficheurCarte afficheur;
	/** diffrence entre les coordonnes du clic et celles du pnj */
	private int ecartX, ecartY;
	
	public ActionDeplacerPnj(ListePnj liste, AfficheurCarte afficheur){
		this.liste = liste;
		this.afficheur = afficheur;
		pnj = null;
	
		afficheur.addMouseListener(this);
		afficheur.addMouseMotionListener(this);
	}

	public void mouseClicked(MouseEvent e) {}
	public void mouseEntered(MouseEvent e) {}
	public void mouseExited(MouseEvent e) {}

	public void mousePressed(MouseEvent e) {
		/* Dclenche le dbut du mouvement */
		if(afficheur.getMode() == AfficheurCarte.MODE_AUCUN && e.isAltDown() == false){
			for(int i=0;i<liste.Nbelement();i++){
				if(e.getX() >= liste.getPnj(i).getX() &&
				e.getY() >= liste.getPnj(i).getY() &&
				e.getX() <= (liste.getPnj(i).getX()+liste.getPnj(i).getImageActuelWidth()) &&
				e.getY() <= (liste.getPnj(i).getY()+liste.getPnj(i).getImageActuelHeigth())){
					pnj = liste.getPnj(i);
					ecartX = e.getX() - pnj.getX();
					ecartY = e.getY() - pnj.getY();
				}
			}
		}
	}

	public void mouseReleased(MouseEvent e) {
		pnj = null;
	}

	public void mouseDragged(MouseEvent e) {
		if(pnj != null){
			pnj.setX(e.getX() - ecartX);
			pnj.setY(e.getY() - ecartY);
		}
	}

	public void mouseMoved(MouseEvent e) {}
}
