package org.system.newEditor;


import java.awt.Color;
import java.awt.Dimension;
import java.awt.GradientPaint;
import java.awt.Graphics;
import java.awt.Graphics2D;

import javax.swing.JPanel;

/**
 * Barre d'etat qui affiche les coordonnes de la  case survole et un message d'aide
 * @author Groupe 6 - 2009
 */
public class BarreEtat extends JPanel{

	private static final long serialVersionUID = 1L;
	
	/** Abcisse de la case survole */
	private int caseX;
	/** Ordonne de la case survole */
	private int caseY;
	/** Message d'aide */
	private String aide;
	
	/** Constructeur de barre d'etat, initialise la taille et les attributs */
	public BarreEtat(){
		aide = new String();
		setDoubleBuffered(true);
		setPreferredSize(new Dimension(getWidth(), 21));
	}
	
	public void paintComponent(Graphics g){
		/* PARTIE DEGRADEE + LIGNES */
		Graphics2D g2d = (Graphics2D)g;         
        GradientPaint gp = new GradientPaint(0, 0, new Color(220, 220, 220), 0, getHeight(), new Color(255, 255, 255), false);
        g2d.setPaint(gp);
        g2d.fillRect(0, 0, this.getWidth(), this.getHeight());
		g.setColor(new Color(204, 204, 204));
		g.drawLine(0, 0, getWidth(), 0);
		g.setColor(new Color(238, 238, 238));
		g.drawLine(0, 1, getWidth(), 1);
		/* FIN DECORATION */
		
		g.setColor(new Color(51, 51, 51));
		g.drawString("[", 4, 14);
		g.drawString(Integer.toString(caseX), 9, 15);
		g.drawString("]", 25, 14);
		
		g.drawString("[", 30, 14);
		g.drawString(Integer.toString(caseY), 35, 15);
		g.drawString("]", 51, 14);
		
		g.drawString(aide, 60, 15);
	}

	public void setCaseX(int caseX) {
		this.caseX = caseX;
	}

	public int getCaseX() {
		return caseX;
	}
	
	public void setCoordonnee(int caseX, int caseY){
		this.caseX = caseX;
		this.caseY = caseY;
		repaint();
	}

	public void setCaseY(int caseY) {
		this.caseY = caseY;
	}

	public int getCaseY() {
		return caseY;
	}

	public void setAide(String aide) {
		this.aide = aide;
		repaint();
	}

	public String getAide() {
		return aide;
	}
	
	public void resetAide(){
		aide = "";
		repaint();
	}
}
