package org.system.newEditor;

import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.ImageIcon;
import javax.swing.JButton;

/**
 *	Bouton ragissant avec le PanneauPnj permettant de selectionner le pnj a placer
 *  On recupere le pnj selectionn dans AfficheurCarte, evenements souris
 * @author Groupe 6 - 2009
 */
public class BoutonPnj extends JButton implements ActionListener{

	private static final long serialVersionUID = 1L;
	
	/** Lien de l'image du pnj */
	private String nomTexture;
	/** Icone du pnj */
	private ImageIcon icone;

	/** Constructeur. Redimensionnement du bouton a la taille de l'image */
	public BoutonPnj(String nomTexture){
		this.nomTexture = nomTexture;
		this.setToolTipText(nomTexture);
		
		this.icone = new ImageIcon(getClass().getResource("/Graphics/Personnage/Monstre/"+nomTexture+"/im0.gif"));
		
		this.setSize(icone.getIconWidth()+1, icone.getIconHeight()+1);
		this.setPreferredSize(new Dimension(icone.getIconWidth()+1, icone.getIconHeight()+1));
		
		this.addActionListener(this);
	}
	
	public void paintComponent(Graphics g){
		g.drawImage(this.icone.getImage(), 1, 1, icone.getIconWidth(), icone.getIconHeight(), this);
	}
	
	/** Le clic sur le bouton envoie les informations du pnj au PanneauPnj */
	public void actionPerformed(ActionEvent e) {
		PanneauPnj.setPnjSelectionnee(nomTexture, icone);
	}
}
