package org.system.newEditor;

import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;

import org.system.Texture;

/**
 * Un bouton sans texte, carr et avec comme fond une texture.
 * En cliquant dessus, la texture est envoy au PanneauTexture via une methode static du panneau
 * @author Groupe 6 - 2009
 */
public class BoutonTexture extends JButton implements ActionListener{

	private static final long serialVersionUID = 1L;
	
	/** La texture associe au bouton */
	private Texture texture;
	private PanneauTexture panneau;

	/**
	 * Cr un BoutonTexture
	 * @param texture La texture associe au bouton
	 */
	public BoutonTexture(Texture texture, PanneauTexture panneau){
		this.setToolTipText(texture.getNom());
		
		/* ces deux lignes sont indispensables pour donner la bonne forme au bouton */
		this.setSize(18, 18);
		this.setPreferredSize(new Dimension(18,18));
		
		this.texture = texture;
		this.panneau = panneau;
		
		/* le bouton attend d'etre cliqu */
		this.addActionListener(this);
	}
	
	public void paintComponent(Graphics g){
		g.drawImage(this.texture.getImage(), 1, 1, 16, 16, this);
	}
	
	/** Quand on clique sur le bouton, il met a jour le PanneauTexture avec sa texture */
	public void actionPerformed(ActionEvent e) {
		PanneauTexture.setTextureSelectionnee(texture.getNom(), texture.getImageIcon());
		PanneauTexture.setTextureSourceSelectionnee(texture.getSource());
		panneau.getPanneauAideBatiment().checkImage(texture.getNom());
	}
}
