package org.system.newEditor;

import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.ImageIcon;
import javax.swing.JButton;

/**
 *	Bouton ragissant avec le PanneauPnj permettant de selectionner le pnj a placer
 *  On recupere le transport selectionn dans AfficheurCarte, evenements souris
 *  Temporaire : la classe transport ne fonctionne pas alors l'ajout dans afficheurCarte est mis en commentaire
 * @author Groupe 6 - 2009
 */
public class BoutonTransport extends JButton implements ActionListener{

	private static final long serialVersionUID = 1L;
	
	/** Nom de l'image, sert a l'affichage du bouton */
	private String nomTexture;
	/** Icone destine  tre envoye au panneauTransport pour son affichage */
	private ImageIcon icone;

	public int indice;
	
	public BoutonTransport(String nomTexture,int indice){
		this.nomTexture = nomTexture;
		this.setToolTipText(nomTexture);
		
		this.indice = indice;
		
		this.icone = new ImageIcon(getClass().getResource("/Graphics/Transport/"+nomTexture+"/im0.gif"));
		
		this.setSize(icone.getIconWidth()+1, icone.getIconHeight()+1);
		this.setPreferredSize(new Dimension(icone.getIconWidth()+1, icone.getIconHeight()+1));
		
		this.addActionListener(this);
	}
	
	public void paintComponent(Graphics g){
		g.drawImage(this.icone.getImage(), 1, 1, icone.getIconWidth(), icone.getIconHeight(), this);
	}
	
	/** Clic sur le bouton met  jour le panneauTransport */
	public void actionPerformed(ActionEvent e) {
		PanneauTransport.setTransportSelectionne(nomTexture, indice, icone);
	}
}
