package org.system.newEditor;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextPane;
import javax.swing.text.BadLocationException;
import javax.swing.text.Style;
import javax.swing.text.StyleConstants;
import javax.swing.text.StyleContext;
import javax.swing.text.StyledDocument;

/**
 * Boite de dialogue avec une aide pour l'diteur
 * @author Groupe 6 - 2009
 */
public class DialogAide extends JDialog{

	private static final long serialVersionUID = 1L;
	
	private JButton okBouton;
	private JTextPane aideTextPane;
	private StyledDocument doc;
	
	public DialogAide(JFrame parent){
		super(parent, "Aide", true);
		this.setSize(550, 400);
		this.setLocationRelativeTo(null);
		this.setResizable(false);
		this.setDefaultCloseOperation(JDialog.HIDE_ON_CLOSE);
		
		this.initialiserComposant();
	}
	
	void initialiserComposant(){
		/*String aideText = "Bonjour, voici la liste des raccourcies utile pour cette Editeur de fou :-)\n\n" +
				"ctrl+N => Nouvelle map\n" +
				"ctrl+O => Ouvrir une map\n" +
				"ctrl+S => Enregistrer la map\n" +
				"alt+entree => Propit de la map\n" +
				"ctrl+Q => Quitter\n" +
				"ctrl+Z => Annuler (permet de revenir jusqu'a 50 action)\n" +
				"ctrl+Y => Rtablir (annule l'annulation)\n" +
				"ctrl+R => Rtablir map\n" +
				"ctrl+V => Verifier la carte (voir si le trsor,clef... sont bien plac\n" +
				"ctrl+G => Affich une grille sur la map afin de facilit la pose d'objet\n" +
				"ctrl+F => Franchissabilit (clickez ensuite sur la case pour la rendre non-franchissable " +
				"ou reclick dessus pour la rendre a nouveau franchissable\n" +
				"ctrl+T => Afficher le panneau de textures\n" +
				"ctrl+P => Afficher le panneau de PNJ\n" +
				"ctrl+E => Afficher le panneau d'lment\n" +
				"alt+click => permet de selectionner une zone et d'y pos une mme texture\n" +
				"ctrl+click => copie la texture\n";*/
		
		
		
		aideTextPane = new JTextPane();
		doc = aideTextPane.getStyledDocument();
		addStylesToDocument(doc);
		
		okBouton = new JButton("Fermer");
		
		aideTextPane.setEditable(false);
		aideTextPane.setOpaque(true);
		
		ajouterTexteAide();
		
		JPanel boutonPanel = new JPanel();
		boutonPanel.add(okBouton);
		
		okBouton.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				setVisible(false);
			}
		});
		
		JScrollPane scroll = new JScrollPane(aideTextPane);
		scroll.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
		scroll.getVerticalScrollBar().setUnitIncrement(10);
		
		this.getContentPane().add(scroll, BorderLayout.CENTER);
		this.getContentPane().add(boutonPanel, BorderLayout.SOUTH);
		

	}
	
	private void addText(String style, String texte) throws BadLocationException{
		if(style.equals("regular") || style.equals("italic") || style.equals("bold") ||
				style.equals("titre") || style.equals("large") || style.equals("soustitre"))
			doc.insertString(doc.getLength(), texte, doc.getStyle(style));
	}
	
	private void ajouterTexteAide(){
		try {
			addText("titre", "Aide de l'diteur de niveaux\n\n");
			addText("soustitre", "1) Raccourcis\n");
			
			addText("bold", "Ctrl + N : "); addText("regular", "Nouvelle carte\n");
			addText("bold", "Ctrl + O : "); addText("regular", "Ouvrir une carte\n");
			addText("bold", "Ctrl + S : "); addText("regular", "Enregistrer la carte\n");
			addText("bold", "Ctrl + Q : "); addText("regular", "Quitter l'diteur\n");
			addText("bold", "Alt + Entre : "); addText("regular", "Proprits de la carte\n");
			addText("bold", "Ctrl + Z : "); addText("regular", "Annuler une modification\n");
			addText("bold", "Ctrl + Y : "); addText("regular", "Rtablir une modification\n\n");
			
			addText("bold", "Ctrl + R : "); addText("regular", "Remplir la carte\n");
			addText("bold", "Ctrl + V : "); addText("regular", "Voir les erreurs de la carte\n");
			addText("bold", "Ctrl + G : "); addText("regular", "Afficher la grille\n");
			addText("bold", "Ctrl + C : "); addText("regular", "Afficher le curseur\n\n");
			
			addText("bold", "Ctrl + F : "); addText("regular", "Affichage des cases non franchissables\n");
			addText("bold", "Ctrl + T : "); addText("regular", "Affichage du panneau des textures\n");
			addText("bold", "Ctrl + P : "); addText("regular", "Affichage du panneau des PNJ\n");
			addText("bold", "Ctrl + E : "); addText("regular", "Affichage des cases spciales (Trsor...)\n\n");
			
			addText("bold", "Ctrl + Clic : "); addText("regular", "(Mode texture) slectionne la texture de la case clique\n");
			addText("bold", "Ctrl + Clic (enfonc) : "); addText("regular", "(Mode franchissabilit) les cases cliques deviennent franchissable\n");
			addText("bold", "Alt + Clic (enfonc) : "); addText("regular", "Selectionne plusieurs cases\n");
			addText("bold", "Ctrl + Touches directionnelles : "); addText("regular", "Dplace la slection\n");
			addText("bold", "R : "); addText("regular", "Repositionne la carte en haut a gauche\n");
			addText("bold", "Touches directionnelles : "); addText("regular", "Dplacer la carte\n");
		} catch (BadLocationException e) {
			e.printStackTrace();
		}
	}
	
	private void addStylesToDocument(StyledDocument doc) {
        Style def = StyleContext.getDefaultStyleContext().getStyle(StyleContext.DEFAULT_STYLE);

        Style regular = doc.addStyle("regular", def);

        Style s = doc.addStyle("italic", regular);
        StyleConstants.setItalic(s, true);

        s = doc.addStyle("bold", regular);
        StyleConstants.setBold(s, true);

        s = doc.addStyle("titre", regular);
        StyleConstants.setBold(s, true);
        StyleConstants.setFontSize(s, 16);

        s = doc.addStyle("soustitre", regular);
        StyleConstants.setBold(s, true);
        StyleConstants.setFontSize(s, 14);
        
        s = doc.addStyle("large", regular);
        StyleConstants.setFontSize(s, 16);
        
        s = doc.addStyle("icon", regular);
        StyleConstants.setAlignment(s, StyleConstants.ALIGN_CENTER);
        ImageIcon iconeSelectionneur = new ImageIcon("Graphics/Editeur/selectionneur.png", "selectionneur");
        if (iconeSelectionneur != null) {
            StyleConstants.setIcon(s, iconeSelectionneur);
        }
    }

}
