package org.system.newEditor;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;

import org.system.Carte;
import org.system.Clef;

/**
 * Fenetre permettant de positionner la cl,en demandant une combinaison
 * @author Groupe 6 - 2009
 */
public class DialogClef extends JDialog {

	private static final long serialVersionUID = 1L;
	
	private JButton okBouton, annulerBouton;

	private JLabel statusLabel;
	private PanneauCombinaison combinaisonPanneau;
	
	private Carte carte;
	private int caseX;
	private int caseY;
	
	public DialogClef(JFrame parent, Carte carte, int caseX, int caseY, boolean modifier){
		super(parent, "", true);
		this.setSize(400, 170);
		this.setLocationRelativeTo(null);
		this.setResizable(false);
		this.setDefaultCloseOperation(JDialog.HIDE_ON_CLOSE);
		
		this.carte = carte;
		this.caseX = caseX;
		this.caseY = caseY;
		
		this.initialiserComposant(modifier);
		
		this.setVisible(true);
	}
	
	/**
	 * Initialise les composants graphiques de la fenetre
	 * @param modifier si vrai, on charge la combinaison dans le panneauCombinaison. Si faux, le panneauCombinaison est vide
	 */
	public void initialiserComposant(boolean modifier){
		
		combinaisonPanneau = new PanneauCombinaison("Entrez la combinaison de touches pour afficher la cl :", 3, this.getWidth());
		
		if(modifier == true){
			okBouton = new JButton("Modifier");
			
			/* On met a jour avec les combinaisons actuelle */
			combinaisonPanneau.setCombinaison(carte.getCase(caseX, caseY).getCombinaison());
		}
		else{
			this.setTitle("Poser la cl");
			okBouton = new JButton("Poser");
		}
		
		// zone status
		statusLabel = new JLabel("");
		statusLabel.setForeground(Color.RED);
		JPanel statusPanel = new JPanel();
		statusPanel.setPreferredSize(new Dimension(360, 30));

		statusPanel.add(statusLabel);
		
		// zone bouton
		annulerBouton = new JButton("Annuler");
		JPanel boutonPanel = new JPanel();
		
		boutonPanel.add(okBouton);
		boutonPanel.add(annulerBouton);
		
		//conteneur principal
		JPanel conteneurPanel = new JPanel();
		conteneurPanel.add(combinaisonPanneau);
		conteneurPanel.add(statusPanel);
		
		annulerBouton.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e) {
				setVisible(false);
			}			
		});
		
		okBouton.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e) {
				if(combinaisonPanneau.getCombinaison() != null){
					carte.getNiveau()[caseX][caseY] = new Clef(carte.getCase(caseX, caseY), combinaisonPanneau.getCombinaison());
					setVisible(false);
				}else {
					statusLabel.setText("Veuillez entrer une combinaison pour l'explorateur");
				}
			}			
		});
		
		this.getContentPane().add(conteneurPanel, BorderLayout.CENTER);
		this.getContentPane().add(boutonPanel, BorderLayout.SOUTH);
	}
}
