package org.system.newEditor;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectOutputStream;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;

import org.system.Carte;

/**
 * Boite de dialogue demandant une confirmation en quittant l'diteur
 * si la carte n'a pas t enregistre.
 * @author Groupe 6 - 2009
 */
public class DialogQuitter extends JDialog {

	private static final long serialVersionUID = 1L;
	
	private JButton okBouton, annulerBouton,quitterBouton;

	private Carte carte;
	
	public DialogQuitter(JFrame parent ,Carte carte){
		
		
		super(parent, "Editeur", true);
		this.setSize(500, 140);
		this.setLocationRelativeTo(null);
		this.setResizable(false);
		this.setAlwaysOnTop(true);
		this.setDefaultCloseOperation(JDialog.HIDE_ON_CLOSE);
		this.carte = carte;
		carteDifferente();
		
		if(carteDifferente()){
			this.initialiserComposant();
			this.setAlwaysOnTop(true);
			
			this.setVisible(true);
		}else
			System.exit(0);
	}
	
	public boolean carteDifferente(){
		long tailleTempFile = 0;
	    FileOutputStream fichier = null;
		ObjectOutputStream oos = null;
		
		try {
			fichier = new FileOutputStream("maps/temporary.tmp");
			
			oos = new ObjectOutputStream(fichier);
			oos.writeObject(carte);
			oos.close();
			
			File tempFile = new File("maps/temporary.tmp");
			tailleTempFile = tempFile.length();
			tempFile.delete();
		} catch (FileNotFoundException e1) {
			e1.printStackTrace();
		} catch (IOException e2) {
			e2.printStackTrace();
		}
		
		File existingFile = new File("maps/"+carte.getNomCarte()+".map");
		
		if(existingFile.exists()){
			if(tailleTempFile == existingFile.length())
				return false;
		}
	    
	    return true;
	}
	
	public void initialiserComposant(){
		JPanel panelArret = new JPanel();
		JLabel labelArret = new JLabel("Voulez vous enregistrez les modifications de "+carte.getNomCarte()+"?");
		panelArret.setPreferredSize(new Dimension(370, 50));
		panelArret.add(labelArret);
		
		//zone bouton
		okBouton = new JButton("Enregistrer");
		quitterBouton= new JButton ("Ne pas enregistrer");
		annulerBouton = new JButton("Annuler");
		JPanel boutonPanel = new JPanel();
		boutonPanel.setPreferredSize(new Dimension(280, 30));
		boutonPanel.add(okBouton);
		boutonPanel.add(quitterBouton);
		boutonPanel.add(annulerBouton);
		
		// conteneur principal
		JPanel conteneurPanel = new JPanel();
		conteneurPanel.add(panelArret);
		
		
		okBouton.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg) {
				setVisible(false);
				@SuppressWarnings("unused")
				DialogEnregistrer dialogEnregistrer = new DialogEnregistrer(null, carte);
				setTitle("Chasse au trsor - Editeur de niveaux [" + carte.getNomCarte()+"]");
				System.exit(0);
			}
		});
		
		annulerBouton.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e) {
				setVisible(false);
			}			
		});
		
		
		quitterBouton.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e) {
				System.exit(0);
			}			
		});
		
		this.getContentPane().add(conteneurPanel, BorderLayout.NORTH);
		this.getContentPane().add(boutonPanel, BorderLayout.CENTER);
	}
}
	
	
	
	
	

