package org.system.newEditor;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JPanel;

import org.system.Carte;

/**
 * Boite de dialogue permettant de remplir la carte d'une texture choisie.
 * @author Groupe 6 - 2009
 */
public class DialogRemplirCarte extends JDialog
{

	private static final long serialVersionUID = 1L;
	
	private JButton okBouton, annulerBouton;
	private JComboBox textureBox;
	private Carte carte;
	
	public DialogRemplirCarte(JFrame parent,Carte carte)
	{
		super(parent, "Remplissage", true);
		this.setSize(200, 170);
		this.setLocationRelativeTo(null);
		this.setResizable(false);
		this.setDefaultCloseOperation(JDialog.HIDE_ON_CLOSE);
		this.initialiserComposant();
		this.carte = carte;
		this.setVisible(true);
	}
	
	public void initialiserComposant()
	{
		// zone bouton
		okBouton = new JButton("Remplir");
		annulerBouton = new JButton("Annuler");
		JPanel boutonPanel = new JPanel();
		
		boutonPanel.add(okBouton);
		boutonPanel.add(annulerBouton);
		
		//zone texture remplissage

		textureBox = new JComboBox();
		for(int i=0;i<FenetreEditeur.getListeTextureBasique().getLongueur();i++){
			textureBox.addItem(FenetreEditeur.getListeTextureBasique().getListe().get(i).getImageIcon());
		}

		JPanel texturePanel = new JPanel();
		
		texturePanel.setPreferredSize(new Dimension(180, 70));
		texturePanel.setBorder(BorderFactory.createTitledBorder("Texture"));
		texturePanel.add(textureBox);
		
		// conteneur principal
		JPanel conteneurPanel = new JPanel();
		conteneurPanel.add(texturePanel);
		
		annulerBouton.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e) {
				setVisible(false);
			}			
		});
		
		okBouton.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg) {
				
				for(int i=0;i<carte.getLargeur();i++)	{
					for(int j=0;j<carte.getLongueur();j++)	{
						carte.getCase(i, j).setTexture(FenetreEditeur.getListeTextureBasique().getListe().get(textureBox.getSelectedIndex()));
					}
				}
				
				setVisible(false);
			}
		});
		
		this.getContentPane().add(conteneurPanel, BorderLayout.CENTER);
		this.getContentPane().add(boutonPanel, BorderLayout.SOUTH);
	}
	public Carte getCarte(){
		return this.carte;
	}
}

