package org.system.newEditor;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;

import org.system.Carte;
import org.system.Tresor;

/**
 * Fenetre permettant de positionner le trsor, en demandant une combinaison pour les diffrente types de personnage
 * @author Groupe 6 - 2009
 */
public class DialogTresor extends JDialog{

	private static final long serialVersionUID = 1L;
	
	private JButton okBouton, annulerBouton;

	private JLabel statusLabel;
	private PanneauCombinaison combinaisonPanneau1;
	private PanneauCombinaison combinaisonPanneau2;
	private PanneauCombinaison combinaisonPanneau3;
	
	private Carte carte;
	private int caseX;
	private int caseY;
	
	public DialogTresor(JFrame parent, Carte carte, int caseX, int caseY, boolean modifier){
		super(parent, "", true);
		this.setSize(400, 300);
		this.setLocationRelativeTo(null);
		this.setResizable(false);
		this.setDefaultCloseOperation(JDialog.HIDE_ON_CLOSE);
		
		this.carte = carte;
		this.caseX = caseX;
		this.caseY = caseY;
		
		this.initialiserComposant(modifier);
		
		this.setVisible(true);
	}
	
	public void initialiserComposant(boolean modifier){
		
		combinaisonPanneau1 = new PanneauCombinaison("Entrez la combinaison de touches pour l'explorateur :", 3, this.getWidth());
		combinaisonPanneau2 = new PanneauCombinaison("Entrez la combinaison de touches pour le sorcier :", 3, this.getWidth());
		combinaisonPanneau3 = new PanneauCombinaison("Entrez la combinaison de touches pour le matre des clefs :", 3, this.getWidth());
		
		if(modifier == true){
			okBouton = new JButton("Modifier");
			
			/* On met a jour avec les combinaisons actuelle */
			combinaisonPanneau1.setCombinaison(carte.getCase(caseX, caseY).getCombinaison());
			combinaisonPanneau2.setCombinaison(((Tresor) carte.getCase(caseX, caseY)).getCombinaison2());
			combinaisonPanneau3.setCombinaison(((Tresor) carte.getCase(caseX, caseY)).getCombinaison3());
		}
		else{
			this.setTitle("Ajouter un trsor");
			okBouton = new JButton("Poser");
		}
		
		// zone status
		statusLabel = new JLabel("");
		statusLabel.setForeground(Color.RED);
		JPanel statusPanel = new JPanel();
		statusPanel.setPreferredSize(new Dimension(360, 30));

		statusPanel.add(statusLabel);
		
		// zone bouton
		annulerBouton = new JButton("Annuler");
		JPanel boutonPanel = new JPanel();
		
		boutonPanel.add(okBouton);
		boutonPanel.add(annulerBouton);
		
		//conteneur principal
		JPanel conteneurPanel = new JPanel();
		conteneurPanel.add(combinaisonPanneau1);
		conteneurPanel.add(combinaisonPanneau2);
		conteneurPanel.add(combinaisonPanneau3);
		conteneurPanel.add(statusPanel);
		
		annulerBouton.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e) {
				setVisible(false);
			}			
		});
		
		okBouton.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e) {
				if(combinaisonPanneau1.getCombinaison() != null){
					if(combinaisonPanneau2.getCombinaison() != null){
						if(combinaisonPanneau3.getCombinaison() != null){
							carte.getNiveau()[caseX][caseY] = new Tresor(carte.getCase(caseX, caseY), combinaisonPanneau1.getCombinaison(), combinaisonPanneau2.getCombinaison(), combinaisonPanneau3.getCombinaison());
							carte.getCase(caseX,caseY).setVisible(false);
							carte.tresor = (Tresor) carte.getCase(caseX,caseY);
							setVisible(false);
						}else {
							statusLabel.setText("Veuillez entrer une combinaison pour le matre des clefs");
						}	
					}else {
						statusLabel.setText("Veuillez entrer une combinaison pour le sorcier");
					}	
				}else {
					statusLabel.setText("Veuillez entrer une combinaison pour l'explorateur");
				}
			}			
		});
		
		
	
		this.getContentPane().add(conteneurPanel, BorderLayout.CENTER);
		this.getContentPane().add(boutonPanel, BorderLayout.SOUTH);
	}
	
	public int[] obtenirCombinaison(JComboBox[] comboBox){
		int longueurCombinaison = 0;
		int i, j;
		
		for(i=0;i<3;i++){
			for(j=0;j<3;j++){
				if(i != j)
					if(comboBox[i].getSelectedItem().toString().charAt(0) == comboBox[j].getSelectedItem().toString().charAt(0))
						comboBox[j].setSelectedIndex(0);
			}
		}
		
		for(i=0;i<3;i++)
			if(comboBox[i].getSelectedItem().toString() != " ")
				longueurCombinaison++;
		
		if(longueurCombinaison == 0) return null;
		
		int[] combinaison = new int[longueurCombinaison];
		j=0;
		for(i=0;i<3;i++){
			if(comboBox[i].getSelectedItem().toString() != " "){
				combinaison[j] = (int)comboBox[i].getSelectedItem().toString().charAt(0);
				j++;
			}
		}
		
		return combinaison;
	}

}
