package org.system.newEditor;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JPopupMenu;

import org.system.Carte;
import org.system.Case;


public class MenuClicDroit extends JPopupMenu{

	private static final long serialVersionUID = 1L;
	
	private Carte carte;
	private int x;
	private int y;
	
	private JMenuItem actionPoserTresor = new JMenuItem("Poser le trsor");
	private JMenuItem actionModifierTresor = new JMenuItem("Modifier le trsor");
	private JMenuItem actionSupprimerTresor = new JMenuItem("Supprimer le trsor");
	
	private JMenuItem actionPoserClef = new JMenuItem("Poser la cl");
	private JMenuItem actionModifierClef = new JMenuItem("Modifier la cl");
	private JMenuItem actionSupprimerClef = new JMenuItem("Supprimer la cl");
	
	private JMenuItem actionPoserIncantation = new JMenuItem("Poser l'incantation");
	private JMenuItem actionModifierIncantation = new JMenuItem("Modifier l'incantation");
	private JMenuItem actionSupprimerIncantation = new JMenuItem("Supprimer l'incantation");
	
	private JMenuItem actionAjouterIndice = new JMenuItem("Poser un indice");
	private JMenuItem actionModifierIndice = new JMenuItem("Modifier cet indice");
	private JMenuItem actionSupprimerIndice = new JMenuItem("Supprimer cet indice");
	
	private JMenuItem actionAjouterTeleporteur = new JMenuItem("Poser un tlporteur");
	private JMenuItem actionModifierTeleporteur = new JMenuItem("Modifier ce tlporteur");
	private JMenuItem actionSupprimerTeleporteur = new JMenuItem("Supprimer ce tlporteur");
	
	private JMenu menuPnj;
	
	public MenuClicDroit(JPanel parent, Carte carte, int x, int y){
		this.carte = carte;
		this.x = x;
		this.y = y;
		
		this.initialiserEcouteur();
		this.initialiserComposant();
	}
	
	public void initialiserEcouteur(){
		/* TRESOR */
		actionPoserTresor.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				@SuppressWarnings("unused")
				DialogTresor dialogTresor = new DialogTresor(null, carte, x/16, y/16, false);
			}
		});
		
		actionModifierTresor.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				@SuppressWarnings("unused")
				DialogTresor dialogTresor = new DialogTresor(null, carte, x/16, y/16, true);
			}
		});
		
		actionSupprimerTresor.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				carte.getNiveau()[x/16][y/16] = new Case(carte.getCase(x/16,y/16));
			}
		});
		
		/* INDICE */
		actionAjouterIndice.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				@SuppressWarnings("unused")
				DialogIndice dialogIndice = new DialogIndice(null, carte, x/16, y/16, false);
			}
		});
		
		actionModifierIndice.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				@SuppressWarnings("unused")
				DialogIndice dialogIndice = new DialogIndice(null, carte, x/16, y/16, true);
			}
		});
		
		actionSupprimerIndice.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				carte.getNiveau()[x/16][y/16] = new Case(carte.getCase(x/16,y/16));
			}
		});
		
		/* CLEF */
		actionPoserClef.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				@SuppressWarnings("unused")
				DialogClef dialogClef = new DialogClef(null, carte, x/16, y/16, false);
			}
		});
		
		actionModifierClef.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				@SuppressWarnings("unused")
				DialogClef dialogClef = new DialogClef(null, carte, x/16, y/16, true);
			}
		});
		
		actionSupprimerClef.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				carte.getNiveau()[x/16][y/16] = new Case(carte.getCase(x/16,y/16));
			}
		});
		
		/* INCANTATION */
		actionPoserIncantation.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				@SuppressWarnings("unused")
				DialogIncantation dialogIncantation = new DialogIncantation(null, carte, x/16, y/16, false);
			}
		});
		
		actionModifierIncantation.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				@SuppressWarnings("unused")
				DialogIncantation dialogIncantation = new DialogIncantation(null, carte, x/16, y/16, true);
			}
		});
		
		actionSupprimerIncantation.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				carte.getNiveau()[x/16][y/16] = new Case(carte.getCase(x/16,y/16));
			}
		});
		
		/* TELEPORTEUR */
		actionAjouterTeleporteur.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				@SuppressWarnings("unused")
				DialogTeleporteur dialogTeleporteur = new DialogTeleporteur(null, carte, x/16, y/16, false);
			}
		});
		
		actionModifierTeleporteur.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				@SuppressWarnings("unused")
				DialogTeleporteur dialogTeleporteur = new DialogTeleporteur(null, carte, x/16, y/16, true);
			}
		});
		
		actionSupprimerTeleporteur.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent arg0) {
				carte.getNiveau()[x/16][y/16] = new Case(carte.getCase(x/16,y/16));
			}
		});
	}
	
	public void initialiserComposant(){
		boolean tresorDejaPose = false;
		boolean clefDejaPose = false;
		boolean incantationDejaPose = false;
		
		for(int i=0; i<carte.getLargeur(); i++){
			for(int j=0; j<carte.getLongueur(); j++){
				if(carte.getCase(i, j).getClass().getName().equals("org.system.Tresor")){
					tresorDejaPose = true;
				}else if(carte.getCase(i, j).getClass().getName().equals("org.system.Clef")){
					clefDejaPose = true;
				}else if(carte.getCase(i, j).getClass().getName().equals("org.system.Incantation")){
					incantationDejaPose = true;
				}
			}
		}
		
		if(carte.getCase(x/16,y/16).getClass().getName().equals("org.system.Tresor")){
			this.add(actionModifierTresor);
			this.add(actionSupprimerTresor);
		}else if(carte.getCase(x/16,y/16).getClass().getName().equals("org.system.Indice")){
			this.add(actionModifierIndice);
			this.add(actionSupprimerIndice);
		}else if(carte.getCase(x/16,y/16).getClass().getName().equals("org.system.Clef")){
			this.add(actionModifierClef);
			this.add(actionSupprimerClef);
		}else if(carte.getCase(x/16,y/16).getClass().getName().equals("org.system.Incantation")){
			this.add(actionModifierIncantation);
			this.add(actionSupprimerIncantation);
		}else if(carte.getCase(x/16,y/16).getClass().getName().equals("org.system.Teleporteur")){
			this.add(actionModifierTeleporteur);
			this.add(actionSupprimerTeleporteur);
		}else{
			if(tresorDejaPose == false)
				this.add(actionPoserTresor);
			if(clefDejaPose == false)
				this.add(actionPoserClef);
			if(incantationDejaPose == false)
				this.add(actionPoserIncantation);
			this.add(actionAjouterIndice);
			this.add(actionAjouterTeleporteur);
		}
	}


	public void ajouterAction(JMenuItem action){
		if(menuPnj == null){
			menuPnj = new JMenu("Supprimer pnj");
			this.addSeparator();
			this.add(menuPnj);
		}
		
		menuPnj.add(action);
	}

}
