package org.system.newEditor;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;

import javax.swing.BorderFactory;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;

/**
 * Un panneau avec les textures de plusieurs thmes...
 * @author Groupe 6 - 2009
 */
public class PanneauTexture extends JDialog{

	private static final long serialVersionUID = 1L;
	
	/** Le conteneur des pages des diffrents thmes */
	private JTabbedPane onglet;
	/** lien vers l'image selectionne */
	private static String textureSourceSelectionnee;
	/** nom de l'image selectionne */
	private static JLabel textureSelectionnee;
	/** icone de l'image selectionne */
	private static ImageIcon iconeTextureSelectionnee;
	/** composant parent */
	private FenetreEditeur parent;
	/** panneau d'aide pour les batiments complexes */
	private PanneauAideBatiment panneauAideBatiment;
	
	public PanneauTexture(FenetreEditeur parent){
		super(parent, "Liste des textures", false);
		this.parent = parent;
		this.setSize(260, 520);
		this.setLocationRelativeTo(null);
		this.setResizable(false);
		this.setDefaultCloseOperation(JFrame.HIDE_ON_CLOSE);

		initialiserComposant();
	}
	
	void initialiserComposant(){
		int i;
		onglet = new JTabbedPane();
		
		/* PARTIE TEXTURE SELECTIONNEE */
		JPanel panelStatus = new JPanel();
		try {
			textureSelectionnee = new JLabel(FenetreEditeur.getListeTextureMontagneTerrain().trouveByNom("herbe.png").getNom());
			setIconeTextureSelectionnee(FenetreEditeur.getListeTextureMontagneTerrain().trouveByNom("herbe.png").getImageIcon());
			setTextureSourceSelectionnee(FenetreEditeur.getListeTextureMontagneTerrain().trouveByNom("herbe.png").getSource());
			setTextureSelectionnee("herbe.png", FenetreEditeur.getListeTextureMontagneTerrain().trouveByNom("herbe.png").getImageIcon());
		} catch (Exception e1) {
			e1.printStackTrace();
		}
	
		panelStatus.add(textureSelectionnee);
		
		/* PARTIE REMPLIR SELECTION */
		JButton boutonRemplirSelection = new JButton("Remplir la slection");
		boutonRemplirSelection.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e) {
				ArrayList<SauvegardeCase> tmpListe = new ArrayList<SauvegardeCase>();
				
				if(parent.getAfficheur().getSelectionneur().hasSelection()){
					for(int i=parent.getAfficheur().getSelectionneur().getP1().x/16;i<=(parent.getAfficheur().getSelectionneur().getP1().x/16)+parent.getAfficheur().getSelectionneur().getEcartX();i++){
						for(int j=parent.getAfficheur().getSelectionneur().getP1().y/16;j<=(parent.getAfficheur().getSelectionneur().getP1().y/16)+parent.getAfficheur().getSelectionneur().getEcartY();j++){
							tmpListe.add(new SauvegardeCase(parent.getAfficheur().getCarte().getCase(i,j), i, j));
							parent.getAfficheur().getCarte().getCase(i,j).setImageIcon(getIconeTextureSelectionnee(), getTextureSelectionnee(), getTextureSourceSelectionnee());
						}
					}
				}
				
				AfficheurCarte.getListeAnnuler().ajouterSauvegarde(tmpListe);
				AfficheurCarte.getListeRetablir().getListeCase().clear();
				
				parent.getAfficheur().getSelectionneur().reset();
			}			
		});
		
		/* *************** */
		/* PARTIE MONTAGNE */
		/* *************** */
		
		/* Cration des sous conteneurs */
		JPanel panelMontagne = new JPanel();
		JPanel panelMontagneTerrain = new JPanel();
		JPanel panelMontagneObstacle = new JPanel();
		JPanel panelMontagneBatiment = new JPanel();
		
		panelMontagne.setPreferredSize(new Dimension(230, 400));
		
		panelMontagneTerrain.setPreferredSize(new Dimension(220, 150));
		panelMontagneTerrain.setBorder(BorderFactory.createTitledBorder("Terrain"));
		
		panelMontagneObstacle.setPreferredSize(new Dimension(220, 152));
		panelMontagneObstacle.setBorder(BorderFactory.createTitledBorder("Obstacles"));
		
		panelMontagneBatiment.setPreferredSize(new Dimension(220, 62));
		panelMontagneBatiment.setBorder(BorderFactory.createTitledBorder("Btiments"));
		
		/* Instanciation du tableau de boutons */
		BoutonTexture[] boutonMontagneTerrain = new BoutonTexture[FenetreEditeur.getListeTextureMontagneTerrain().getLongueur()];
		
		/* Instanciation de chaque bouton associ a une texture */
		for(i=0;i<FenetreEditeur.getListeTextureMontagneTerrain().getLongueur();i++){ 
			boutonMontagneTerrain[i] = new BoutonTexture(FenetreEditeur.getListeTextureMontagneTerrain().getTexture(i), this);
			boutonMontagneTerrain[i].setIcon(FenetreEditeur.getListeTextureMontagneTerrain().getTexture(i).getImageIcon());
			panelMontagneTerrain.add(boutonMontagneTerrain[i]);
		}
		
		BoutonTexture[] boutonMontagneObstacle = new BoutonTexture[FenetreEditeur.getListeTextureMontagneObstacle().getLongueur()];
		
		for(i=0;i<FenetreEditeur.getListeTextureMontagneObstacle().getLongueur();i++){ 
			boutonMontagneObstacle[i] = new BoutonTexture(FenetreEditeur.getListeTextureMontagneObstacle().getTexture(i), this);
			boutonMontagneObstacle[i].setIcon(FenetreEditeur.getListeTextureMontagneObstacle().getTexture(i).getImageIcon());
			panelMontagneObstacle.add(boutonMontagneObstacle[i]);
		}
		
		BoutonTexture[] boutonMontagneBatiment = new BoutonTexture[FenetreEditeur.getListeTextureMontagneBatiment().getLongueur()];
		
		for(i=0;i<FenetreEditeur.getListeTextureMontagneBatiment().getLongueur();i++){ 
			boutonMontagneBatiment[i] = new BoutonTexture(FenetreEditeur.getListeTextureMontagneBatiment().getTexture(i), this);
			boutonMontagneBatiment[i].setIcon(FenetreEditeur.getListeTextureMontagneBatiment().getTexture(i).getImageIcon());
			panelMontagneBatiment.add(boutonMontagneBatiment[i]);
		}
		
		panelMontagne.add(panelMontagneTerrain);
		panelMontagne.add(panelMontagneObstacle);
		panelMontagne.add(panelMontagneBatiment);
		
		/* *************** */
		/* PARTIE TROPICAL */
		/* *************** */
		JPanel panelTropical = new JPanel();
		JPanel panelTropicalTerrain = new JPanel();
		JPanel panelTropicalObstacle = new JPanel();
		JPanel panelTropicalBatiment = new JPanel();
		
		panelTropical.setPreferredSize(new Dimension(230, 400));
		
		panelTropicalTerrain.setPreferredSize(new Dimension(220, 130));
		panelTropicalTerrain.setBorder(BorderFactory.createTitledBorder("Terrain"));
		
		panelTropicalObstacle.setPreferredSize(new Dimension(220, 83));
		panelTropicalObstacle.setBorder(BorderFactory.createTitledBorder("Obstacles"));
		
		panelTropicalBatiment.setPreferredSize(new Dimension(220, 107));
		panelTropicalBatiment.setBorder(BorderFactory.createTitledBorder("Btiments"));
		
		BoutonTexture[] boutonTropicalTerrain = new BoutonTexture[FenetreEditeur.getListeTextureTropicalTerrain().getLongueur()];
		
		for(i=0;i<FenetreEditeur.getListeTextureTropicalTerrain().getLongueur();i++){ 
			boutonTropicalTerrain[i] = new BoutonTexture(FenetreEditeur.getListeTextureTropicalTerrain().getTexture(i), this);
			boutonTropicalTerrain[i].setIcon(FenetreEditeur.getListeTextureTropicalTerrain().getTexture(i).getImageIcon());
			panelTropicalTerrain.add(boutonTropicalTerrain[i]);
		}
		
		BoutonTexture[] boutonTropicalObstacle = new BoutonTexture[FenetreEditeur.getListeTextureTropicalObstacle().getLongueur()];
		
		for(i=0;i<FenetreEditeur.getListeTextureTropicalObstacle().getLongueur();i++){ 
			boutonTropicalObstacle[i] = new BoutonTexture(FenetreEditeur.getListeTextureTropicalObstacle().getTexture(i), this);
			boutonTropicalObstacle[i].setIcon(FenetreEditeur.getListeTextureTropicalObstacle().getTexture(i).getImageIcon());
			panelTropicalObstacle.add(boutonTropicalObstacle[i]);
		}
		
		BoutonTexture[] boutonTropicalBatiment = new BoutonTexture[FenetreEditeur.getListeTextureTropicalBatiment().getLongueur()];
		
		for(i=0;i<FenetreEditeur.getListeTextureTropicalBatiment().getLongueur();i++){ 
			boutonTropicalBatiment[i] = new BoutonTexture(FenetreEditeur.getListeTextureTropicalBatiment().getTexture(i), this);
			boutonTropicalBatiment[i].setIcon(FenetreEditeur.getListeTextureTropicalBatiment().getTexture(i).getImageIcon());
			panelTropicalBatiment.add(boutonTropicalBatiment[i]);
		}
		
		

		panelTropical.add(panelTropicalTerrain);
		panelTropical.add(panelTropicalObstacle);
		panelTropical.add(panelTropicalBatiment);
		
		/* *************** */
		/* PARTIE CHATEAU */
		/* *************** */
		JPanel panelChateau = new JPanel();
		JPanel panelChateauTerrain = new JPanel();
		JPanel panelChateauObstacle = new JPanel();
		
		panelChateau.setPreferredSize(new Dimension(230, 400));
		
		panelChateauTerrain.setPreferredSize(new Dimension(220, 100));
		panelChateauTerrain.setBorder(BorderFactory.createTitledBorder("Terrain"));
		
		panelChateauObstacle.setPreferredSize(new Dimension(220, 100));
		panelChateauObstacle.setBorder(BorderFactory.createTitledBorder("Obstacles"));
		
		BoutonTexture[] boutonChateauTerrain = new BoutonTexture[FenetreEditeur.getListeTextureChateauTerrain().getLongueur()];
		
		for(i=0;i<FenetreEditeur.getListeTextureChateauTerrain().getLongueur();i++){ 
			boutonChateauTerrain[i] = new BoutonTexture(FenetreEditeur.getListeTextureChateauTerrain().getTexture(i), this);
			boutonChateauTerrain[i].setIcon(FenetreEditeur.getListeTextureChateauTerrain().getTexture(i).getImageIcon());
			panelChateauTerrain.add(boutonChateauTerrain[i]);
		}
		
		BoutonTexture[] boutonChateauObstacle = new BoutonTexture[FenetreEditeur.getListeTextureChateauObstacle().getLongueur()];
		
		for(i=0;i<FenetreEditeur.getListeTextureChateauObstacle().getLongueur();i++){ 
			boutonChateauObstacle[i] = new BoutonTexture(FenetreEditeur.getListeTextureChateauObstacle().getTexture(i), this);
			boutonChateauObstacle[i].setIcon(FenetreEditeur.getListeTextureChateauObstacle().getTexture(i).getImageIcon());
			panelChateauObstacle.add(boutonChateauObstacle[i]);
		}
		
		panelChateau.add(panelChateauTerrain);
		panelChateau.add(panelChateauObstacle);
		
		panneauAideBatiment = new PanneauAideBatiment(this);
		
		/* RASSEMBLEMENT */
		JPanel center = new JPanel();
		onglet.add("Montagne", panelMontagne);
		onglet.add("Tropical", panelTropical);
		onglet.add("Chateau", panelChateau);
		
		JScrollPane scroll = new JScrollPane(onglet);
		scroll.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
		scroll.getVerticalScrollBar().setUnitIncrement(10);
		center.add(scroll);
		center.add(panneauAideBatiment);
		
		this.getContentPane().add(panelStatus, BorderLayout.NORTH);
		this.getContentPane().add(boutonRemplirSelection, BorderLayout.SOUTH);
		this.getContentPane().add(center, BorderLayout.CENTER);
	}

	public static void setTextureSelectionnee(String nomTexture, ImageIcon icone) {
		PanneauTexture.textureSelectionnee.setText(nomTexture);
		PanneauTexture.textureSelectionnee.setIcon(icone);
		iconeTextureSelectionnee = icone;
	}

	public static String getTextureSelectionnee() {
		return textureSelectionnee.getText();
	}

	public static void setIconeTextureSelectionnee(ImageIcon iconeTextureSelectionnee) {
		PanneauTexture.iconeTextureSelectionnee = iconeTextureSelectionnee;
	}

	public static ImageIcon getIconeTextureSelectionnee() {
		return iconeTextureSelectionnee;
	}

	public static void setTextureSourceSelectionnee(
			String textureSourceSelectionnee) {
		PanneauTexture.textureSourceSelectionnee = textureSourceSelectionnee;
	}

	public static String getTextureSourceSelectionnee() {
		return textureSourceSelectionnee;
	}

	public void setPanneauAideBatiment(PanneauAideBatiment panneauAideBatiment) {
		this.panneauAideBatiment = panneauAideBatiment;
	}

	public PanneauAideBatiment getPanneauAideBatiment() {
		return panneauAideBatiment;
	}
}
